// Angular-client joka käyttää websocket-serviceä

import { Component } from '@angular/core';
import {WebsocketService} from './websocket.service';

@Component({
  selector: 'app-root',
  providers: [ WebsocketService ],
  template: `<h2>Angular subscriber to WebSocket service</h2>
       {{messageFromServer}}<br>
       <button (click)="sendMessageToServer()">Send message to Server</button>
  `})

  export class AppComponent {

    messageFromServer: string;
    i: number;

// WebSocketService -injektoidaan konstruktoriin
// ja sitä käytetään nimellä wsService
    constructor(private wsService: WebsocketService) {

        this.i = 1;

        this.wsService.createObservableSocket('ws://localhost:8085')
          .subscribe(
              data => {
                this.messageFromServer = data;
              },
              err => console.log( err),
              () =>  console.log( 'The observable stream is complete')
          );
    }
      sendMessageToServer() {
          console.log('Sending message to WebSocket server');
          this.wsService.sendMessage('Hello from client ' + this.i);
          this.i++;
      }
  }
