/* WebSocketService luo WebSocket -olion client-puolelle 
 * ja palauttaa observablen joka luodaan Websocket-oliosta.
 */
import { Injectable } from '@angular/core';
import { Observable } from 'rxjs';

@Injectable({
  providedIn: 'root'
})
export class WebsocketService {

  ws: WebSocket;

  createObservableSocket(url: string): Observable<any> {

    this.ws = new WebSocket(url);

    return new Observable(
      observer => {
        this.ws.onmessage = (event) =>
          observer.next(event.data);
        this.ws.onerror = (event) => observer.error(event);
        this.ws.onclose = (event) => observer.complete();
      }
    );
  }
  // sendMessage lähettää viestin clientilta
  sendMessage(message: any) {
    this.ws.send(message);
  }
}
